import  java.awt.*;
import java.awt.event.*;

class  JScanvas extends  Canvas  implements MouseMotionListener,MouseListener
{
   jsammon parent;
   double minx,maxx,miny,maxy;
   
   public void autoscale()
     {  /* seleziona le boundaries in modo da mostrare tutti i punti */
       HiPoint p;
       int i;
       p=parent.dataset.myElementAt(0);
       minx=maxx=p.x;
       miny=maxy=p.y;
       for(i=1; i<parent.dataset.size(); i++)
         {
           p=parent.dataset.myElementAt(i);
           if(p.x<minx) minx=p.x;
           if(p.x>maxx) maxx=p.x;
           if(p.y<miny) miny=p.y;
           if(p.y>maxy) maxy=p.y;
         }
     }
     
   public void zoom(double factor)
     {
       double minx1,maxx1,miny1,maxy1;
       minx1=(maxx+minx)/2.0-(maxx-minx)*factor/2.0;
       maxx1=(maxx+minx)/2.0+(maxx-minx)*factor/2.0;
       miny1=(maxy+miny)/2.0-(maxy-miny)*factor/2.0;
       maxy1=(maxy+miny)/2.0+(maxy-miny)*factor/2.0;
       minx=minx1;
       maxx=maxx1;
       miny=miny1;
       maxy=maxy1;
       repaint();
     }
   
   public void scroll(double sx,double sy)
     {
       minx=minx+(maxx-minx)*sx;
       maxx=maxx+(maxx-minx)*sx;
       miny=miny+(maxy-miny)*sy;
       maxy=maxy+(maxy-miny)*sy;
       repaint();
     }

   JScanvas(jsammon pa)
      {
        parent=pa;
        resize(500,500);
        autoscale();
        addMouseMotionListener(this);
        addMouseListener(this);
      }

    public void mouseClicked(MouseEvent mouseEvent)
    {
    }

    public void mouseEntered(MouseEvent mouseEvent)
    {
    }

    public void mouseExited(MouseEvent mouseEvent)
    {
      parent.r1.setText("");
      parent.r2.setText("");
    }

    public void mousePressed(MouseEvent mouseEvent)
    {
    }

    public void mouseReleased(MouseEvent mouseEvent)
    {
    }

    public void mouseDragged(MouseEvent mouseEvent)
    {
    }

    public void mouseMoved(MouseEvent mouseEvent)
    {
      HiPoint p,pb;
      int i;
      double mind,d;
      int mx=mouseEvent.getX();
      int my=mouseEvent.getY();
      double x=(((double)mx-20d)/(size().width-40d))*(maxx-minx)+minx;
      double y=(((double)size().height-my-20d)/(size().height-40d))*(maxy-miny)+miny;
      parent.r1.setText("x="+x+", y="+y);
      pb=parent.dataset.myElementAt(0);
      mind=(pb.onscreen_x-mx)*(pb.onscreen_x-mx)
            +(pb.onscreen_y-my)*(pb.onscreen_y-my);
      for(i=1; i<parent.dataset.size(); i++)
        {
           p=parent.dataset.myElementAt(i);
           d=(p.onscreen_x-mx)*(p.onscreen_x-mx)
               +(p.onscreen_y-my)*(p.onscreen_y-my);
           if(d<mind) {pb=p; mind=d;}
        }
      parent.r2.setText(pb.toString());
    }

    void draw_dataset(Graphics g)    
      {
        Color colorlist[]= {Color.white,Color.yellow,Color.cyan,Color.orange,Color.magenta,Color.pink,Color.blue,Color.red,Color.green};
       HiPoint p;
       int i;
       for(i=0; i<parent.dataset.size(); i++)
         {
           p=parent.dataset.myElementAt(i);
           p.onscreen_x=(int)(20+(size().width-40)*(p.x-minx)/(maxx-minx));
           p.onscreen_y=(int)(size().height-20-(size().height-40)*(p.y-miny)/(maxy-miny));
           draw_cross(g,p.onscreen_x,p.onscreen_y,colorlist[p.cls%colorlist.length]);
         }        
      }
      
    void draw_cross(Graphics g,int x,int y,Color c)
      {
        g.setColor(c);
        g.drawLine(x-2,y,x+2,y);
        g.drawLine(x,y-2,x,y+2);
        /* System.out.println("Drawing a cross at "+x+","+y); */
      }
      
    public void paint(Graphics g)
      {
       g.setColor(Color.black);
        g.fillRect(0,0,size().width,size().height);
        draw_dataset(g);
      }
}
